Module:    dylan-user
Synopsis:  Dylan MSXML3 wrapper
Author:    Chris Double
Copyright: Copyright (c) 2001, Chris Double.  All rights reserved.

define module com-utilities
  use functional-dylan;
  use com;
  use c-ffi;
  use ole-automation;

  export 
    let-com-interface,
    query-interface,
    convert-to-string,
    convert-to-safe-type;
end module com-utilities;

define module msxml3
  use functional-dylan;
  use finalization;
  use com;
  use c-ffi;
  use ole-automation;
  use msxml3-dispatch;
  use com-utilities;

  // Add binding exports here.
  export 
    <msxml-proxy>,
    msxml3-interface,
    proxy-class,
    proxy-method-definer,
    proxy-method-setter-definer,
    make-proxy,
    <parse-error>,
    parse-error-code,
    parse-error-url,
    parse-error-reason,
    parse-error-src-text,
    parse-error-line,
    parse-error-line-pos,
    parse-error-file-pos,
    \dom-parse-error-methods-definer,
    <schema-collection>,
    \dom-schema-collection-methods-definer,
    schema-collection-add,
    schema-collection-get,
    schema-collection-remove,
    schema-collection-length,
    schema-collection-add-collection,
    <implementation>,
    \dom-implementation-methods-definer,
    implementation-has-feature,
    <named-node-map>,
    \dom-named-node-map-methods-definer,
    named-node-map-get-named-item,
    named-node-map-set-named-item,
    named-node-map-remove-named-item,
    named-node-map-length,
    named-node-map-get-qualified-item,
    named-node-map-remove-qualified-item,
    named-node-map-next-node,
    named-node-map-reset,
    <node-type>,
    node-type-from-index,
    node-classes-from-type,
    <node>,
    \dom-node-methods-definer,
    node-name,
    node-value,
    node-type,
    node-parent-node,
    node-child-nodes,
    node-first-child,
    node-last-child,
    node-previous-sibling,
    node-next-sibling,
    node-attributes,
    node-insert-before,
    node-replace-child,
    node-remove-child,
    node-append-child,
    node-has-child-nodes?,
    node-owner-document,
    node-clone-node,
    node-type-string,
    node-text,
    node-text-setter,
    node-specified?,
    node-definition,
    node-typed-value,
    node-typed-value-setter,
    node-data-type,
    node-data-type-setter,
    node-xml,
    node-transform-node,
    node-select-nodes,
    node-select-single-node,
    node-parsed?,
    node-namespace-uri,
    node-prefix,
    node-base-name,
    node-transform-node-to-object,
    <document-type>,
    \dom-document-type-methods-definer,
    document-type-name,
    document-type-entities,
    document-type-notations,
    <element>,
    \dom-element-methods-definer,
    element-tag-name,
    element-get-attribute,
    element-set-attribute,
    element-remove-attribute,
    element-get-attribute-node,
    element-set-attribute-node,
    element-remove-attribute-node,
    element-normalize,
    element-get-elements-by-tag-name,
    <attribute>,
    \dom-attribute-methods-definer,
    attribute-name,
    attribute-value,
    attribute-value-setter,
    <document-fragment>,
    \dom-document-fragment-methods-definer,
    <character-data>,
    \dom-character-data-methods-definer,
    character-data,
    character-data-setter,
    character-data-length,
    character-data-substring-data,
    character-data-append-data,
    character-data-insert-data,
    character-data-delete-data,
    character-data-replace-data,
    <text>,
    \dom-text-methods-definer,
    text-split-text,
    <comment>,
    \dom-comment-methods-definer,
    <cdata-section>,
    \dom-cdata-section-methods-definer,
    <processing-instruction>,
    \dom-processing-instruction-methods-definer,
    processing-instruction-target,
    processing-instruction-data,
    processing-instruction-data-setter,
    <entity-reference>,
    \dom-entity-reference-methods-definer,
    <document>,
    \dom-document-methods-definer,
    document-doctype,
    document-implementation,
    document-element,
    document-create-element,
    document-create-document-fragment,
    document-create-text-node,
    document-create-comment,
    document-create-cdata-section,
    document-create-processing-instruction,
    document-create-attribute,
    document-create-entity-reference,
    document-get-elements-by-tag-name,
    document-create-node,
    document-node-from-id,
    document-load,
    document-ready-state,
    document-parse-error,
    document-url,
    document-async?,
    document-async?-setter,
    document-abort,
    document-load-xml,
    document-save,
    document-validate-on-parse?,
    document-validate-on-parse?-setter,
    document-resolve-externals?,
    document-resolve-externals?-setter,
    document-preserve-whitespace?,
    document-preserve-whitespace?-setter,
    <document2>,
    \dom-document2-methods-definer,
    document-namespaces,
    document-schemas,
    document-validate,
    document-set-property,
    document-get-property,
    <notation>,
    \dom-notation-methods-definer,
    notation-public-id,
    notation-system-id,
    <entity>,
    \dom-entity-methods-definer,
    entity-public-id,
    entity-system-id,
    entity-notation-name,
    msxml3-initialize,
    make-document,
    make-free-threaded-document,
    make-schema-cache,
    make-xsl-template;
 end module msxml3;
