Module:    dylan-user
Synopsis:  An FFI wrapper for Curl.
Author:    Chris Double
Copyright: Copyright (c) 2001, Chris Double.  All rights reserved.

define module lib-curl
  use functional-dylan;
  use c-ffi;
  use sockets, import: { start-sockets };

  // Add binding exports here.
  export 
    <curl>,
    <curl-option>,
    <curl-code>,
    $curle-ok,
    $curle-unsupported-protocol,
    $curle-failed-init,
    $curle-url-malformat,
    $curle-url-maxlformat-user,
    $curle-couldnt-resolve-proxy,
    $curle-couldnt-resolve-host,
    $curle-couldnt-connect,
    $curle-ftp-weird-server-reply,
    $curle-ftp-access-denied,
    $curle-ftp-user-password-incorrect,
    $curle-ftp-weird-pass-reply,
    $curle-ftp-weird-user-reply,
    $curle-ftp-weird-pasv-reply,
    $curle-ftp-weird-227-reply,
    $curle-ftp-cant-get-host,
    $curle-ftp-cant-reconnect,
    $curle-ftp-couldnt-set-binary,
    $curle-partial-file,
    $curle-ftp-couldnt-retr-file,
    $curle-ftp-write-error,
    $curle-ftp-quote-error,
    $curle-http-not-found,
    $curle-write-error,
    $curle-malformat-user,
    $curle-ftp-couldnt-stor-file,
    $curle-read-error,
    $curle-out-of-memory,
    $curle-operation-timeouted,
    $curle-ftp-couldnt-set-ascii,
    $curle-ftp-port-failed,
    $curle-ftp-couldnt-user-rest,
    $curle-ftp-couldnt-get-size,
    $curle-http-range-error,
    $curle-http-post-error,
    $curle-ssl-connect-error,
    $curle-ftp-bad-download-resume,
    $curle-file-couldnt-read-file,
    $curle-ldap-cannot-bind,
    $curle-ldap-search-failed,
    $curle-library-not-found,
    $curle-function-not-found,
    $curle-aborted-by-callback,
    $curle-bad-function-argument,
    $curle-bad-calling-order,
    $curle-http-port-failed,
    $curle-bad-password-entered,
    $curle-too-many-redirects,
    $curle-unknown-telnet-option,
    $curle-telnet-option-syntax,
    $curle-obsolete,
    $curle-ssl-peer-certificate,
    $curlopt-nothing,
    $curlopt-file,
    $curlopt-url,
    $curlopt-port,
    $curlopt-proxy,
    $curlopt-userpwd,
    $curlopt-proxyuserpwd,
    $curlopt-range,
    $curlopt-infile,
    $curlopt-errorbuffer,
    $curlopt-writefunction,
    $curlopt-readfunction,
    $curlopt-timeout,
    $curlopt-infilesize,
    $curlopt-postfields,
    $curlopt-referer,
    $curlopt-ftpport,
    $curlopt-useragent,
    $curlopt-low-speed-limit,
    $curlopt-low-speed-time,
    $curlopt-resume-from,
    $curlopt-cookie,
    $curlopt-httpheader,
    $curlopt-httppost,
    $curlopt-sslcert,
    $curlopt-sslcertpasswd,
    $curlopt-crlf,
    $curlopt-quote,
    $curlopt-writeheader,
    $curlopt-moredocs,
    $curlopt-cookiefile,
    $curlopt-sslversion,
    $curlopt-timecondition,
    $curlopt-timevalue,
    $curlopt-customrequest,
    $curlopt-stderr,
    $curlopt-postquote,
    $curlopt-writeinfo,
    $curlopt-verbose,
    $curlopt-header,
    $curlopt-noprogress,
    $curlopt-nobody,
    $curlopt-failonerror,
    $curlopt-upload,
    $curlopt-post,
    $curlopt-ftplistonly,
    $curlopt-ftpappend,
    $curlopt-netrc,
    $curlopt-followlocation,
    $curlopt-ftpascii,
    $curlopt-transfertext,
    $curlopt-put,
    $curlopt-mute,
    $curlopt-progressfunction,
    $curlopt-progressdata,
    $curlopt-autoreferer,
    $curlopt-proxyport,
    $curlopt-postfieldsize,
    $curlopt-httpproxytunnel,
    $curlopt-interface,
    $curlopt-krb4level,
    $curlopt-ssl-verifypeer,
    $curlopt-cainfo,
    $curlopt-passwdfunction,
    $curlopt-passwddata,
    $curlopt-maxredirs,
    $curlopt-filetime,
    $curlopt-telnetoptions,
    $curlopt-maxconnects,
    $curlopt-closepolicy,
    $curlopt-closefunction,
    $curlopt-fresh-connect,
    $curlopt-forbid-reuse,
    $curlopt-random-file,
    $curlopt-egdsocket,
    $curlopt-connecttimeout,
    $curlopt-headerfunction,    
    curl-easy-init,
    curl-easy-cleanup,
    curl-easy-setopt,
    *header-function-callback*,
    c-header-function-callback,
    *write-function-callback*,
    c-write-function-callback,
    curl-easy-perform,
    curl-formparse,
    curl-formfree,
    <form-pointer>,
    <form-pointer*>,
    curl-escape,
    curl-unescape,
    start-lib-curl,
    stop-lib-curl;
end module lib-curl;

